using System.Net.Http;
using System.Security.Principal;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Components;
using Microsoft.AspNetCore.Components.Authorization;
using Microsoft.AspNetCore.Components.Forms;
using Microsoft.AspNetCore.Components.Routing;
using Microsoft.AspNetCore.Components.Web;
using Microsoft.AspNetCore.Components.Web.Virtualization;
using Microsoft.JSInterop;
using Radzen;
using Radzen.Blazor;

namespace Net8Server.Components.Pages
{
    public partial class Index
    {
        [Inject]
        protected IJSRuntime JSRuntime { get; set; }

        [Inject]
        protected NavigationManager NavigationManager { get; set; }

        [Inject]
        protected DialogService DialogService { get; set; }

        [Inject]
        protected TooltipService TooltipService { get; set; }

        [Inject]
        protected ContextMenuService ContextMenuService { get; set; }

        [Inject]
        protected NotificationService NotificationService { get; set; }

        [Inject]
        protected SecurityService Security { get; set; }

        WindowsIdentity windowsIdentity;

        [Inject]
        IHttpContextAccessor ContextAccessor { get; set;}

        [CascadingParameter]
        public Task<AuthenticationState> AuthenticationState { get; set; }
            
        protected override async Task OnInitializedAsync()
        {
            var authenticationState = await AuthenticationState;
            var user = authenticationState.User.Identity as WindowsIdentity;

            //var user = ContextAccessor.HttpContext.User.Identity as WindowsIdentity;
            WindowsIdentity.RunImpersonated(user.AccessToken, () => 
            {
                windowsIdentity = WindowsIdentity.GetCurrent();
            });
        }
    }
}